Imports System.Drawing.Drawing2D
Imports System.Math

Public Class Form1
    Private m_Colors() As Color = {Color.Red, Color.Orange, Color.Yellow, Color.Green, Color.Blue, Color.Indigo, Color.Violet}
    Private m_FillColorNumber As Integer = 1
    Private m_BackColor As Color = m_Colors(0)
    Private m_FillColor As Color = m_Colors(m_FillColorNumber)
    Private m_SweepAngle As Single = 0
    Private m_CircleBounds As Rectangle

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_CircleBounds = New Rectangle(20, 20, Me.ClientSize.Width - 40, Me.ClientSize.Height - 40)
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.UserPaint Or _
            ControlStyles.DoubleBuffer, True)
        Me.UpdateStyles()
    End Sub

    ' If the user clicked on the circle, start filling.
    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        Dim cx As Integer = m_CircleBounds.X + m_CircleBounds.Width \ 2
        Dim cy As Integer = m_CircleBounds.Y + m_CircleBounds.Height \ 2
        If (cx - e.X) * (cx - e.X) + (cy - e.Y) * (cy - e.Y) <= 100 * 100 Then
            tmrFiller.Enabled = True
        End If
    End Sub

    ' Draw the circle.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        ' Color the circle's background.
        Using br As New SolidBrush(m_BackColor)
            e.Graphics.FillEllipse(br, m_CircleBounds)
        End Using

        ' If the timer is enabled, fill part of the circle.
        If tmrFiller.Enabled Then
            ' Color the circle's filled part.
            Using br As New SolidBrush(m_FillColor), gp As New GraphicsPath()
                Dim start_angle As Single = 90 - m_SweepAngle / 2
                gp.AddArc(m_CircleBounds, start_angle, m_SweepAngle)
                e.Graphics.FillPath(br, gp)
                m_SweepAngle += 20
            End Using

            ' Increase the sweep angle.
            m_SweepAngle = CSng(m_SweepAngle + PI / 10)

            ' See if we're done with this color.
            If m_SweepAngle > 360 Then
                tmrFiller.Enabled = False
                m_BackColor = m_FillColor
                m_FillColorNumber = (m_FillColorNumber + 1) Mod m_Colors.Length
                m_FillColor = m_Colors(m_FillColorNumber)
                m_SweepAngle = 0
            End If
        End If

        ' Outline the circle.
        e.Graphics.DrawEllipse(Pens.Black, m_CircleBounds)
    End Sub

    ' Redraw.
    Private Sub tmrFiller_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrFiller.Tick
        Me.Invalidate()
    End Sub
End Class
